package com.memorynotfound.jndi;

import javax.annotation.Resource;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.*;
import javax.sql.DataSource;
import java.io.*;
import java.sql.*;

@WebServlet(urlPatterns = "/*")
public class WelcomeServlet extends HttpServlet {

    @Resource(name="jdbc/DatabaseName")
    private DataSource ds;

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        Statement stmt = null;
        ResultSet rs = null;
        try {
            Connection con = ds.getConnection();
            stmt = con.createStatement();

            rs = stmt.executeQuery("select id, name, email from tbl_users");

            PrintWriter out = resp.getWriter();
            resp.setContentType("text/html");
            out.write("<html>");
            out.write("<body>");

            out.write("<h3>Database Records</h3>");
            while(rs.next())  {
                out.write("id: " + rs.getInt("id") + " ");
                out.write("name: " + rs.getString("name") + " ");
                out.write("email: " + rs.getString("email") + " ");
                out.write("</br>");
            }

            //lets print some DB information
            out.write("<h3>Database Meta Data</h3>");
            DatabaseMetaData metaData = con.getMetaData();
            out.write("Database Product: " + metaData.getDatabaseProductName() + "<br/>");
            out.write("Database Version: " + metaData.getDatabaseMajorVersion() + "."
                    + metaData.getDatabaseMinorVersion() + "<br/>");
            out.write("Database Driver: " + metaData.getDriverName() + "<br/>");
            out.write("Database Driver version: " + metaData.getDriverMajorVersion() + "."
                    + metaData.getDriverMinorVersion() + "<br/>");
            out.write("Database user: " + metaData.getUserName());
            out.write("</html>");

        } catch (SQLException e) {
            e.printStackTrace();
        } finally{
            try {
                if (rs != null) {
                    rs.close();
                }
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                System.out.println("Exception in closing DB resources");
            }
        }
    }
}
